﻿using System.Windows;
using System.Windows.Navigation;
using Microsoft.Phone.Controls;

namespace UriMapperSample.MainModule
{
    public partial class App : Application
    {
        private bool phoneApplicationInitialized = false;

        public PhoneApplicationFrame RootFrame { get; private set; }

        public App()
        {
            InitializeComponent();

            InitializePhoneApplication();
        }

        private void InitializePhoneApplication()
        {
            if (phoneApplicationInitialized)
                return;

            RootFrame = new PhoneApplicationFrame();
            RootFrame.Navigated += CompleteInitializePhoneApplication;

            // ②App.xaml.csのルートフレームにUriMapperを登録
            RootFrame.UriMapper = Resources["UriMappings"] as UriMapper;

            phoneApplicationInitialized = true;
        }

        private void CompleteInitializePhoneApplication(object sender, NavigationEventArgs e)
        {
            if (RootVisual != RootFrame)
                RootVisual = RootFrame;

            RootFrame.Navigated -= CompleteInitializePhoneApplication;
        }
    }
}